<?php

/*
The code provided below has been thoroughly tested and is guaranteed to work correctly.

However, it is possible that some of the code may become outdated due to updates and cause errors.
In such cases, please send an email to (SCode.info) with the following code and a description of the error,
 so that we can update the code and fix any potential problems.

*/


/*
Time zone based on:

Central European Time => UTC +1:00

1 hour = 60 minutes = 3600 seconds

To find your time zone, go to the following address:
https://scode.info/articles/utc-time-zone/

Then convert your time zone to seconds as shown above.
*/ 
$time_zone = 3600;

$today = date( "Y-m-d", time() + $time_zone );
$yesterday = date( "Y-m-d", time() - 86400 + $time_zone );

$week_visit = 0;
$month_visit = 0;
$month_str = null;

$file_src = get_template_directory() . '/templates/visit/visit-statistics.txt';
chmod( $file_src, 0755 );

$read_file = file_get_contents( $file_src );
if ( filesize( $file_src ) > 0 || $read_file != '' ) {
    $split_file = explode( '|', $read_file );
    $modify = $split_file[ 31 ];

    if ( $modify != $today ) {
        $today_visit = 1;

        if ( $modify == $yesterday ) {
            $yesterday_visit = $split_file[ 0 ];
        } else {
            $yesterday_visit = 0;
        }

        $week_visit += $today_visit + $yesterday_visit;
        $month_visit += $today_visit + $yesterday_visit;

        for ( $i = 2; $i < 30; $i++ ) {
            if (is_numeric($split_file[$i - 1])) {
                $month_str .= intval($split_file[ $i - 1 ]);
            } else {
              if (is_numeric($data)) {
               // If the data is numeric, return it as an integer
                return intval($data);
            } else {
              // If the data is non-numeric, check if it contains an integer
                if (preg_match('/(\d+)/', $data, $matches)) {
            // If an integer is found, return it
                    return intval($matches[0]);
                } else {
                   // Return 0 if integer not found
                    return 0;
                }
            }
            }

            if ( $i < 29 ) {
                $month_str .= '|';
            }

            if ( $i < 8 ) {
                $week_visit += intval($split_file[ $i - 1 ]);
            }

            $month_visit += intval($split_file[ $i - 1 ]);
        }

        $total_visit = 0; // Initialize with a default value (0 visits)

        if (is_numeric($split_file[30])) {
            $total_visit =  $split_file[30];
        }
        $total_visit += 1; // Add 1 to the total visit count

        $last_modify = $today;
    } else {
        $today_visit = intval($split_file[ 0 ] + 1);
        $yesterday_visit = intval($split_file[ 1 ]);
        $week_visit += $today_visit + $yesterday_visit;
        $month_visit += $today_visit + $yesterday_visit;

        for ( $i = 2; $i < 30; $i++ ) {
            if (is_numeric($split_file[$i])) {
                $month_str .= intval($split_file[ $i]);
            } else {
              if (is_numeric($data)) {
               // If the data is numeric, return it as an integer
                return intval($data);
            } else {
                // If the data is non-numeric, check if it contains an integer
                if (preg_match('/(\d+)/', $data, $matches)) {
                // If an integer is found, return it
                    return intval($matches[0]);
                } else {
                    // Return 0 if integer not found
                    return 0;
                }
            }
            }

            if ( $i < 29 ) {
                $month_str .= '|';
            }

            if ( $i < 8 ) {
                $week_visit += intval($split_file[ $i]);
            }

            $month_visit += intval($split_file[ $i ]);
        }

        $total_visit = intval($split_file[ 30 ] + 1);
        $last_modify = $today;
    }
} else {
    $today_visit = 1;
    $yesterday_visit = 0;
    $week_visit = 1;
    $month_visit = 1;

    for ( $i = 2; $i < 30; $i++ ) {
        $month_str .= '0';

        if ( $i < 29 ) {
            $month_str .= '|';
        }
    }

    $total_visit = 1;
    $last_modify = $today;
}

$file_src_handle = fopen( $file_src, 'w+' );
$visit_data = $today_visit . '|' . $yesterday_visit . '|' . $month_str . '|' . $total_visit . '|' . $last_modify;
fwrite( $file_src_handle, $visit_data );
fclose( $file_src_handle );

$config_array = array(
  'user_time' => date( "YmdHis", time() + $time_zone ),
  'user_ip' => $_SERVER[ 'REMOTE_ADDR' ],
  'file_name' => get_template_directory() . '/templates/visit/visit-online.txt'
);
chmod( $config_array[ 'file_name' ], 0755 );

$online_file = file_get_contents( $config_array[ 'file_name' ] );

$online_file = explode( "\r\n", $online_file );

foreach ( $online_file as $key => $value ) {
  if ( is_null( $value ) || $value == '' ) {
    unset( $online_file[ $key ] );
  }
}

foreach ( $online_file as $key => $value ) {
  $user_ip_time = explode( "|", $value );
  if ( $user_ip_time[ 1 ] <= date( "YmdHis", time() + $time_zone - 300 ) ) {
    unset( $online_file[ $key ] );
  }

  if ( $user_ip_time[ 0 ] == $config_array[ 'user_ip' ] ) {
    unset( $online_file[ $key ] );
  }
}

$online = 1;
foreach ( $online_file as $online_users ) {
  $user_ip_time = explode( "|", $online_users );
  if ( $user_ip_time[ 1 ] >= date( "YmdHis", time() + $time_zone - 300 ) ) {
    $online++;
  }
}

$new_online = $config_array[ 'user_ip' ] . "|" . $config_array[ 'user_time' ] . "\r\n";
foreach ( $online_file as $key => $value ) {
  $new_online .= $value . "\r\n";
}

$file_src_handle = fopen( $config_array[ 'file_name' ], 'w+' );
fwrite( $file_src_handle, $new_online );
fclose( $file_src_handle );